//Регистрация решенных задач
function [err,msg]=RegisteredSolvedTaskMsg(SolvedTask,..//Решенна задача
                                           SolvedTaskMsgs,..//Сообщение решенной задачи
                                           ProjectName,..//Имя проекта
                                           errPrintMsg..//Необходимость печати сообщений об ошибках
                                           )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('The function RegisteredSolvedTaskMsg 2, 3, or 4 arguments');
    end
    select nArg
    case 2 then
        ProjectName = "";//Имя проекта по умолчанию отсутcтвует
        errPrintMsg = %t;//По умолчанию печатаем сообщение об ошибках
    case 3 then
        if type(ProjectName) == 4 then
            errPrintMsg = ProjectName;
            ProjectName = "";//Имя проекта по умолчанию отсутcтвует
        else
            errPrintMsg = %t;//По умолчанию печатаем сообщения об ошибках
        end
    end
    
    //Извлекаем из строк последующие задачи, для которых готовы данные
    NextTasksNames = [];//Имена последующих задач, для которых готовы данные
    for SolvedTaskMsg=matrix(SolvedTaskMsgs,1,-1)
        //Получаем заголовок
        Header = stripblanks(strsplit(SolvedTaskMsg,':'));//Заголовок и сами задачи
        strTasks = Header(2);
        Header(2:$) = [];//оставляем заголовок
        if Header ~= 'Reseivig datas for solving next tasks' then
            NextTasksNames = [];
            err = 3;
            msg = 'The task ' + SolvedTask + ' was solved with error';
            if errPrintMsg then
                error(msg);
            else
                return;
            end
        end
        strTasks = stripblanks(strsplit(strTasks,','));//Выделяем имена задач
        NextTasksNames = [NextTasksNames,strTasks];//Добавляем в общие имена задач
    end
    
    //Регистрируем полученные задачи
    [err,msg]=RegisteredSolvedTask(SolvedTask,NextTasksNames,..
                                   ProjectName,errPrintMsg);
endfunction
